<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class ParseCommand
 * @package FiloBlu\Flow\Console\Command
 */
class ParseCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $state;

    /**
     * ParseCommand constructor.
     * @param \Magento\Framework\App\State $state
     */
    public function __construct(
        \Magento\Framework\App\State $state
    )
    {
        $this->state = $state;
        parent::__construct();
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:parse')->setDescription('Parse data channels');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|void|null
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->state->setAreaCode('adminhtml');
        } catch (\Exception $ex) {
            $output->writeln("Areacode was already set, skipping!");
        }
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        /** @var \FiloBlu\Flow\Cron\Fetch cronModel */
        $this->cronModel = $objectManager->create('\FiloBlu\Flow\Cron\Fetch');
        $this->cronModel->parse();
        $output->writeln('<info>Parsed executed !</info>');
    }

}